Morph subclass: #ElementsMethodEditorMorph
	instanceVariableNames: 'classChooser methodChooser sideChooser palette editor saver methodModified fillScreenOn currentMethod currentClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 01:28'!
about
	self inform: '- Elements -

a graphical Smalltalk
------------------------------
experimental release of Aug. 24 2009
 
written by Jens Mnig (jens@moenig.org)
all rights reserved
 
inspired by Scratch from the MIT Media Lab
and based in part on the Scratch Source Code.
Implemented in Squeak and in itself.'! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 23:05'!
arrangeElements
	| current x y spacing |
	spacing _ 5.
	current _ self currentMethodElement.
	x _ editor contents left + spacing.
	y _ current stackBottom + spacing.
	editor contents submorphsDo: [:element |
		(element == current) ifFalse:[
			element position: x @ y.
			y _ element bottom + spacing ]]
		! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 15:47'!
arrangePanes
	classChooser position: self topLeft + 2.
	sideChooser position: classChooser bottomLeft.
	methodChooser position: sideChooser bottomLeft.
	editor position: (self left + 4) @ (methodChooser bottom + 4);
		extent: (self width - 180 - 8) @ (self bottom - editor top - 4).
	palette position: editor right @ (classChooser bottom);
		height: self bottom - palette top - 4;
		arrangePanes.
	saver position: (self position x + (palette left - methodChooser right - saver width // 2) ) @ (methodChooser bottom - saver height)
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 22:36'!
buildPanes
	| p m |
	classChooser _ ClassChooserMorph new frame: self; class: Object.
	sideChooser _ InstanceClassSwitchMorph new frame: self.
	methodChooser _ MethodChooserMorph new frame: self; class: Object; selector: #yourself.
	editor _ ElementsScrollFrameMorph new
				color: Color gray;
				borderColor: Color gray.
	p _ PasteUpMorph new borderWidth: 0; color: Color gray darker.
	m _ MethodElementMorph new selector: '' arguments: #().
	editor contents: p.
	p addMorph: m.

	palette _ ElementsPaletteFrameMorph new editorFrame: self; height: self height; arrangePanes.
	saver _ ElementsToggleButtonMorph new flat; label: 'save'; onColor: color offColor: color; target: self; selector: #saveCurrentMethod.
	self
		addMorph: classChooser;
		addMorph: sideChooser;
		addMorph: methodChooser;
		addMorph: editor;
		addMorph: palette;
		addMorph: saver.
	saver isHidden: true! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 01:29'!
contextMenu
	|m|
	m _ CustomMenu new.
	m add: 'clean up' action: #arrangeElements.
"
	m addLine.
	fillScreenOn
		ifTrue: [
			m add: 'switch to development mode' action: #developmentMode.
]
		ifFalse: [m add: 'switch to user mode' action: #userMode.
			m add: 'save image in user mode' action: #saveImage ].
"
	m addLine.
	m add: 'about...' action: #about.

	^m! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 12:21'!
currentClass
	^currentClass! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:24'!
currentMethodElement
	^editor contents findA: MethodElementMorph
	! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 12:01'!
currentSide
	sideChooser ifNil: [^#instance ].
	^sideChooser choice! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:35'!
developmentMode
	fillScreenOn _ false.
	self
		position: World topLeft;
		extent: World extent - 50;
		arrangePanes.
	palette arrangePanes.	
	Preferences disable: #noviceMode.
	Preferences enable: #warnIfNoSourcesFile.
	Preferences enable: #warnIfNoChangesFile.

! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:28'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:44'!
initialize
	fillScreenOn _ false.
	methodModified _ false.
	currentClass _ Object.
	currentMethod _ #yourself.
	super initialize.
	self extent: 600 @ 400.
	color _ Color gray.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:29'!
invokeContextMenu
	|m choice|
	m _ self contextMenu.
	m ifNotNil: [
		choice _ m startUp.
		choice ifNotNil: [self perform: choice] ]! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 13:22'!
maximize
	((self position = World position) and: [
		self extent = World extent])
		ifTrue: [^self].
	self
		position: World topLeft;
		extent: World extent;
		arrangePanes.
	palette arrangePanes.
	self comeToFront
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 15:48'!
methodModified
	methodModified _ true.
	saver isHidden: false.
	saver position: (self position x + (palette left - methodChooser right - saver width // 2) ) @ (methodChooser bottom - saver height)! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 22:47'!
methodTemplate
	| m |
	m _ MethodElementMorph new selector: '' arguments: #().
	self currentMethodElement delete.
	m position: editor contents position.
	editor contents addMorph: m fitMethod.
	self isInWorld ifFalse: [^self].
	methodChooser selector: nil.
	self methodUnmodified! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:32'!
methodUnmodified
	methodModified _ false.
	saver isHidden: true! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 10:46'!
mouseDown: evt
	"Handle a mouse down event."

	evt rightButtonPressed
		ifTrue: [ ^self invokeContextMenu].
	Preferences noviceMode ifTrue: [^self].
	self startDrag: evt
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:59'!
onMethod: aSelector ofClass: aClass
	methodModified _ false.
	currentClass _ aClass.
	classChooser class: aClass.
	currentMethod _ #aSelector.
	methodChooser selector: aSelector.
	methodChooser class: aClass.
	palette class: aClass.
"	self refresh"! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 01:09'!
refresh
	self methodTemplate! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:58'!
saveCurrentMethod
	| se sel|
	se _ self currentMethodElement.
	sel _ se selector.

	currentClass compile: se asSmalltalk
					classified: ClassOrganizer nullCategory
					notifying: nil.

	methodChooser selector: sel.
	self selectMethod: sel.
	palette refresh! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 01:07'!
saveImage

	self userMode.
	self maximize.
	World allMorphsDo: [:m|
		(m isKindOf: SystemWindow)
			ifTrue: [m delete ]].
	World activeHand saveAndQuit! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 20:50'!
selectClass: aClass
	editor ifNil: [^self].
	(currentClass = aClass)
		ifTrue: [^self].

	currentClass _ aClass.
	classChooser class: currentClass.
	methodChooser class: currentClass.
	palette class: currentClass.
	self methodTemplate
	! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 21:28'!
selectMethod: aSelector
	| myMethod temps se |

	currentMethod _ aSelector.
	editor ifNil: [^self].
	currentMethod ifNil: [^self].
	currentClass ifNotNil:
		[myMethod _ currentClass compiledMethodAt: currentMethod ifAbsent: [^self methodTemplate].
		temps _ (currentClass compilerClass new
						parse: myMethod getSourceFromFile asString in: currentClass notifying: nil)
						tempNames.

	se _ ((currentClass decompilerClass new withTempNames: temps)
		decompile: currentMethod in: currentClass method: myMethod) asSyntaxElement.

	self currentMethodElement delete.
	se position: editor contents position.
	editor contents addMorph: se fitMethod.

	^self methodUnmodified.
		].

	^self methodTemplate

! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:38'!
step
	fillScreenOn 
		ifTrue: [self maximize]
		ifFalse: [^self arrangePanes].! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 20:10'!
stepTime
	^0! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 11:17'!
switchToClassSide

	self selectClass: currentClass class! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 11:17'!
switchToInstanceSide

	self selectClass: currentClass allInstances first.! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:33'!
userMode

	fillScreenOn _ true.
	Preferences enable: #noviceMode.
	Preferences disable: #warnIfNoSourcesFile.
	Preferences disable: #warnIfNoChangesFile.

! !
