DialogBoxMorph subclass: #BlockEditorFrameMorph
	instanceVariableNames: 'headerMorph bodyMorph hat answerField definition template receiver bin atomicityToggle resizeMorph resizeOffset '
	classVariableNames: 'UserPos UserSize '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:39'!
adjustExtentToAnswerField

	| answerExt newExt |
	answerExt _ self minExtentForAnswer.
	answerExt > self extent
		ifTrue: [ newExt _ answerExt min: World extent ]
		ifFalse: [ newExt _ self extent ].
	self extent: newExt! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 00:37'!
allBlocks
	| all ans |
	all _ OrderedCollection new.
	hat nextBlock ifNotNil: [
		all addAll: (hat nextBlock allMorphs select: [:m |
			m isKindOf: BlockMorph])].
	answerField ifNotNil: [
		ans _ answerField allMorphs select: [:m |
			m isKindOf: BlockMorph].
		ans size > 0 ifTrue: [
			all addAll: ans]].
	^ all! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 00:46'!
allBlocksFor: id
	^ self allBlocks select: [:b |
		b isCustomBlock and: [
			b id = id]]! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:00'!
buildAnswerField
	| spacer ans |

	(answerField isKindOf: ReporterBlockDropTargetMorph) ifTrue: [
		mainColumn replaceSubmorph: answerField 
						by: (answerField _ Morph new extent: 0@0)].		

	spacer _ answerField.
	#none = definition type
		ifTrue: [^ self].
	ans _ definition answer.
	(ans isKindOf: BlockMorph)
		ifTrue: [ans refreshAttributeArgs].
	#boolean = definition type
		ifTrue: [answerField _ ReporterBlockDropTargetMorph booleanLabelled: 'report' localized argument: ans]
		ifFalse: [
			ans ifNil: [ans _ 'something' localized ].
			answerField _ ReporterBlockDropTargetMorph labelled: 'report' localized argument: ans].
	mainColumn replaceSubmorph: spacer by: answerField.! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/19/2010 02:46'!
buildAtomicityToggle

	| labelFont  |

	atomicityToggle ifNotNil: [atomicityToggle delete].

	labelFont _ (ScratchFrameMorph getFont: #UploadTagLabel).

	atomicityToggle _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #watcherButtonPressed)
		offForm: (ScratchFrameMorph skinAt: #watcherButton).

	atomicityToggle
		target: self;
		width: 80;
		actionSelector: #toggleAtomicity;
		borderWidth: 0;
		label: 'atomic' localized
		font: labelFont;
		setLabelColor: (Color gray: 0.3);

		setProperty: #balloonText toValue: 'execute as single block' localized.

	mainColumn addMorph: atomicityToggle.
	atomicityToggle on. 
	self updateAtomicityToggle.

! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/3/2010 16:26'!
buildScript
	|nb b|
	nb _ hat nextBlock.
	nb ifNotNil: [nb delete].	
	definition body ifNotNil: [
		b _ definition body fullCopy.
		b refreshAttributeArgs.
		b position: hat position.
		hat nextBlock: b]! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 00:01'!
cascade
	| sf match findMatch |
	sf _ self scratchFrame.
	sf purgeBlockEditors.
	findMatch _ [ match _ sf blockEditors detect: [:editor |
		editor ~= self and: [
			editor position = self position]]
		ifNone: [nil]].
	findMatch value.
	[match isNil] whileFalse: [
		self position: match position + (0@20).
		findMatch value]! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:36'!
centerOnScreen

	super centerOnScreen.
	self updateResizeMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/5/2010 03:15'!
definition
	^definition! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'CWB 8/20/2011 17:30'!
definition: aCustomBlockDefinition

	| def |
	def _ aCustomBlockDefinition.

	hat ifNotNil: [
		def body: hat nextBlock.
		hat delete ].

	(answerField isKindOf: ReporterBlockDropTargetMorph) ifTrue: [
		def type = #none
			ifTrue: [def answer: nil]
			ifFalse: [def answer: answerField argument]].

	definition _ def.
	template _ receiver newCustomBlockFor: def.
	template isTemplate: true.
	template addLabel.
	hat _ ProcedureHatBlockMorph on: template.
	bin addMorph:(hat position: bin position + (10@10)).

	self buildScript.
"	self buildVariables."
"	self buildAtomicityToggle."
	self buildAnswerField.! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:41'!
extent: aPoint
	
	| w newExtent min|

	min _ self class minExtent max: self minExtentForAnswer.

	newExtent _ aPoint max: min.

	bounds extent = newExtent ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: newExtent.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: newExtent.

	UserPos isNil & resizeOffset isNil ifTrue: [
		w _ self world.
		w ifNotNil: [ aPoint = self extent ifFalse: [
			self position: w center - (self extent // 2)]]].  "center on screen"

	self keepOnScreen
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:49'!
fixLayoutForExtent: aPoint

	| bFrame bScroller |

	super fixLayoutForExtent: aPoint.

	titleBin ifNotNil: [ titleBin width: aPoint x " - 40" ].

	bin ifNil: [^ self].

	bScroller _ bin owner.
	bFrame _ bScroller owner.

	bFrame extent: aPoint - (70 @ (120 + answerField height)).
	bScroller extent: bFrame extent.

	self updateResizeMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 01:15'!
getUserResponse
	"Wait for the user to respond, then report their response. The symbol #cancel is returned if the user wishes to cancel the operation. True/false is returned if they respond yes/no, and a string is returned if this this a string input dialog and they don't cancel."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	self openInWorld.

	UserPos isNil 
		ifTrue: [ self centerOnScreen ]
		ifFalse: [self snapToUserDimensions ].
	self cascade.
		
	w _ self world.
	self buttons size > 0 ifTrue: [
		w activeHand newKeyboardFocus: self buttons last].
	tabFields size > 0 ifTrue: [
		w activeHand newKeyboardFocus: (tabFields at: 1)].

	done _ false.
	[done] whileFalse: [w doOneCycle].  "wait for user to press a button"

	^ response
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/18/2009 23:58'!
handlesMouseDown: evt
	^true! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2010 00:33'!
hat
	^hat! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:33'!
initialize
	| line container sl |

	super initialize.
	self title: 'Block Editor' localized.
	resizeMorph _ ScratchResizeMorph ofType: #corner.
	line _ AlignmentMorph newRow
		color: Color transparent.

	answerField _ Morph new extent: 0@0.
	mainColumn addMorph: answerField.
	mainColumn addMorph: line.

	container _ Morph new 	color: Color transparent.

	sl _ ScrollFrameMorph2 new
		growthFraction: 0.0;
		color: ScratchFrameMorph scriptsPaneColor.

	bin _ ScratchScriptsMorph new.
	sl contents: bin.

	line addMorphBack: container.

	sl extent: container extent.
	container addMorph: sl.

	self addMorph: resizeMorph.


! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2010 01:53'!
instancesOf: aCustomBlockId

	| binInstances ansInstances |
	binInstances _ bin allMorphs select: [:m|
		((m isKindOf: CustomCommandBlockMorph) or: [
			m isKindOf: CustomReporterBlockMorph]) and: [
				m id = aCustomBlockId]].
	#none = definition type 
		ifTrue: [^binInstances ].
	(answerField argument isKindOf: BlockMorph) ifFalse: [
		^ binInstances].
	ansInstances _ answerField argument allMorphs select: [:m|
		(m isKindOf: CustomReporterBlockMorph) and: [
		m id = aCustomBlockId]].

	^binInstances, ansInstances
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 00:09'!
justDroppedInto: aMorph event: evt
	"Never embed myself in a morph (e.g. the Stage)."

	super justDroppedInto: aMorph event: evt.
	self keepOnScreen
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:17'!
keepOnScreen

	| min |
	min _ self class minExtent max: self minExtentForAnswer.

	self left < 0 ifTrue: [ self left: 0].
	self top < 0 ifTrue: [ self top: 0].

	self right > Display extent x
		ifTrue: [ resizeOffset 
			ifNil: [ 
				self left: ((Display extent x - self width) max: 0).
				(self right > Display extent x and: [self width > min x])
					ifTrue: [self width: Display extent x - self left ]]
			ifNotNil: [self width: Display extent x - self left]].

	self bottom > Display extent y
		ifTrue: [ resizeOffset 
			ifNil: [	
				self top: ((Display extent y - self height) max: 0). 
				(self bottom > Display extent y and: [self height > min y])
					ifTrue: [self height: Display extent y - self top]]
			ifNotNil: [self height: Display extent y - self top]].

! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:37'!
minExtentForAnswer
	answerField ifNil: [^self class minExtent].
	^ answerField extent + (60 @ 180) min: World extent.
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/19/2009 00:03'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p |
	p _ evt cursorPoint.
	((resizeMorph bounds expandBy: 4) containsPoint: p)
		ifFalse: [evt hand grabMorph: self]
		ifTrue: [resizeOffset _ self bottomRight - p]
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/19/2009 00:12'!
mouseMove: evt

	resizeOffset ifNotNil: [
		self extent: (evt cursorPoint - self topLeft) + resizeOffset ]

! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/19/2009 00:03'!
mouseUp: evt

	resizeOffset _ nil.
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:58'!
position: aPoint

	super position: aPoint.! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 13:12'!
receiver: aScriptableScratchMorph
	receiver _ aScriptableScratchMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/20/2009 22:59'!
rememberUserDimensions
	self class setUserPos: self position size: self extent! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 18:36'!
scratchFrame
	^receiver ownerThatIsA: ScratchFrameMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 01:15'!
snapToUserDimensions

	self extent: UserSize.
	UserPos ifNotNil: [
		self position: UserPos ].
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 09:32'!
step
	resizeOffset notNil | (owner isKindOf: HandMorph)
		ifTrue: [^self ].
	self keepOnScreen 
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/7/2010 22:58'!
template
	^template! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 15:10'!
toggleAtomicity
	definition toggleAtomicity.
	self updateAtomicityToggle
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 18:40'!
topArgMorphAt: aRectangle exclude: aMorph
	"Give feedback about possible drop targets."

	(answerField isKindOf: ReporterBlockDropTargetMorph) 
		ifFalse: [^nil].
	^answerField topArgMorphAt: aRectangle exclude: aMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/18/2009 23:37'!
updateAtomicityToggle
	definition isAtomic
		ifTrue: [atomicityToggle on]
		ifFalse: [atomicityToggle off].
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:33'!
updateResizeMorph
	resizeMorph ifNotNil: [
		resizeMorph position: self bottomRight - bottomRightForm width ]
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 18:40'!
wantsDroppedMorph: aMorph event: evt

	(answerField isKindOf: ReporterBlockDropTargetMorph) 
		ifFalse: [^false].
	^answerField wantsDroppedMorph: aMorph event: evt	! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2011 03:13'!
yes
	"Yes button was pressed."
	| stage sf |

	self rememberUserDimensions.
	self allMorphs do: [:each| 
		(each isKindOf: BlockMorph) ifTrue: [ each litUp: false].
		(each isKindOf: StringFieldMorph) ifTrue: [each keyboardFocusChange: false]].
	definition body: hat nextBlock.
	#none = definition type ifFalse: [
		definition answer: answerField argument ].

	stage _ receiver ownerThatIsA: ScratchStageMorph.
	receiver
		updateCustomBlockDefinitionId: definition id with: definition;
		updateLocalId: definition id withSpec: definition userSpec.

	(definition isGlobal not and: [stage notNil])
		ifFalse: [
			(stage sprites, {stage} copyWithout: receiver) do: [:obj |
				obj
					updateCustomBlockDefinitionId: definition id with: definition;
					updateOnlyLocalId: definition id withSpec: definition userSpec]].	

	sf _ receiver ownerThatIsA: ScratchFrameMorph.
	sf viewerPane categoryChanged: 'variables'.
	#none = definition category ifFalse: [
		sf viewerPane categoryChanged: definition category asString ].
	^ super yes
		
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockEditorFrameMorph class
	instanceVariableNames: ''!

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 00:35'!
initialize
	"BlockEditorFrameMorph initialize"
	self resetDimensions! !

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:41'!
minExtent
	^400 @ 300.! !

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 00:34'!
resetDimensions
	UserPos _ nil.
	UserSize _ self minExtent.! !

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/20/2009 22:56'!
setUserPos: aPoint size: anExtent
	UserPos _ aPoint.
	UserSize _ anExtent.! !


BlockEditorFrameMorph initialize!
