CommandBlockMorph subclass: #IfElseBlockMorph
	instanceVariableNames: 'trueBlock falseBlock nextBlock elseLabel elseBarY topBarBottom blockBottom elseMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
!IfElseBlockMorph commentStamp: '<historical>' prior: 0!
I am an "E" shaped block used for the if-then-else control structure.
!


!IfElseBlockMorph methodsFor: 'initialization' stamp: 'jm 12/13/2005 20:31'!
initialize

	super initialize.
	self color: (Color r: 1.0 g: 0.581 b: 0.194).
! !


!IfElseBlockMorph methodsFor: 'accessing' stamp: 'ee 7/11/2008 22:26'!
nestedBlockAt: aPoint

	| dist |
	trueBlock
		ifNotNil: [dist _ trueBlock - aPoint.
			falseBlock
				ifNotNil: [(dist > (falseBlock - aPoint))
					ifTrue: [^ falseBlock]
					ifFalse: [^ trueBlock]]
				ifNil: [^ trueBlock]]
		ifNil: [^ falseBlock].
! !

!IfElseBlockMorph methodsFor: 'accessing' stamp: 'ee 7/11/2008 22:26'!
stretchHeight: aNumber
	"Temporary"

	^ self
! !


!IfElseBlockMorph methodsFor: 'drawing' stamp: 'jm 12/14/2005 17:39'!
drawBottomBarOn: aCanvas 

	self drawInnerBottomY: self bottom - CBlockBracketThickness - 4 on: aCanvas.
	self drawBottomEdgeOn: aCanvas.

! !

!IfElseBlockMorph methodsFor: 'drawing' stamp: 'ee 8/11/2008 14:46'!
drawElseBarOn: aCanvas

	| left y |
	"these are in absolute coordinates"
	left _ self left + CBlockBracketThickness - 1.
	y _ self top + elseBarY.

	self drawInnerBottomY: y on: aCanvas.

	y _ y + 2.
	aCanvas
		fillRectangle: (left@y corner: (self right - 1)@(y + self elseBarHeight))
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@y corner: self right@(y + self elseBarHeight))
		color: shadowColor.
	self drawInnerTopY: elseBarY + self elseBarHeight + 2 on: aCanvas.
! !

!IfElseBlockMorph methodsFor: 'drawing' stamp: 'jm 12/14/2005 17:42'!
drawInnerBottomY: y on: aCanvas

	| left barBottom |
	left _ self left + CBlockBracketThickness - 1.
	barBottom _ y + (CBlockBracketThickness - 3).

	"fill in bottom-left corner"
	aCanvas fillRectangle: (left@(y - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(y - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@y extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@y corner: (self right - 2)@(y + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (left@(y + 1) corner: (self right - 1)@barBottom)
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@(y + 2) corner: self right@barBottom)
		color: shadowColor.


! !

!IfElseBlockMorph methodsFor: 'drawing' stamp: 'jm 12/14/2005 17:21'!
drawInnerTopY: y on: aCanvas

	| left right gapStart gapEnd |
	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: (right - 1) y: y color: color on: aCanvas.
	self drawHLineFrom: left to: (right - 2) y: y + 1 color: color on: aCanvas.

	"fill in upper-left inside corner"
	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 2 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (right - 1)@y color: shadowColor on: aCanvas.
	self drawPoint: (right - 2)@(y + 1) color: shadowColor on: aCanvas.

! !

!IfElseBlockMorph methodsFor: 'drawing' stamp: 'jens 4/20/2010 22:22'!
drawOn: aCanvas 

	| c |

	self contrastColor.

	topBarBottom _ self top + self topBarHeight.
	blockBottom _ self bottom - 7.

	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.
	self drawTopEdgeOn: c.
	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawElseBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.
! !

!IfElseBlockMorph methodsFor: 'drawing' stamp: 'jm 12/14/2005 17:27'!
drawTopBarOn: aCanvas 

	aCanvas
		fillRectangle: (self left@(self top + 5) corner: (self right - 1)@topBarBottom)
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@(self top + 3) corner: self right @topBarBottom)
		color: shadowColor.

	self drawInnerTopY: topBarBottom - self top on: aCanvas.

! !

!IfElseBlockMorph methodsFor: 'drawing' stamp: 'jm 12/13/2005 20:31'!
drawVerticalBarOn: aCanvas 

	| left top barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.
	top _ self top.
	
	aCanvas
		fillRectangle: (left@(top + 5) corner: barRight@blockBottom)
		color: color.
	aCanvas
		fillRectangle: (left@(top + 2) corner: (left + 2)@blockBottom)
		color: highlightColor2.

	aCanvas
		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.
! !


!IfElseBlockMorph methodsFor: 'geometry' stamp: 'jm 6/21/2009 11:47'!
containsPoint: aPoint

	cachedForm ifNil: [self updateCachedForm].
	^ (self fullBounds containsPoint: aPoint) and:
	  [(cachedForm isTransparentAt: aPoint - self fullBounds origin) not]
! !


!IfElseBlockMorph methodsFor: 'object i/o' stamp: 'jm 12/13/2005 20:31'!
fieldsVersion

	^ 1
! !

!IfElseBlockMorph methodsFor: 'object i/o' stamp: 'jm 12/13/2005 20:39'!
initFieldsFrom: anObjStream version: classVersion

	super initFieldsFrom: anObjStream version: classVersion.
	self initFieldsNamed: #(
		trueBlock
		falseBlock
		nextBlock
	) from: anObjStream.
! !

!IfElseBlockMorph methodsFor: 'object i/o' stamp: 'jm 12/13/2005 20:40'!
storeFieldsOn: anObjStream

	super storeFieldsOn: anObjStream.
	self storeFieldsNamed: #(
		trueBlock
		falseBlock
		nextBlock
	) on: anObjStream.
! !


!IfElseBlockMorph methodsFor: 'private' stamp: 'ee 2/28/2008 17:02'!
addLabel
	"Also add the else label"

	super addLabel.
	elseMorph _ self labelMorphFor: 'else' localized.
	self addMorphBack: elseMorph.
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jens 12/16/2009 21:23'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg argList |
	blockTuple _ Array new: argMorphs size + 5.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	argList _ argMorphs.
	argList _ self organizeArgs: argList.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph)
			ifTrue: [blockTuple at: i + 3 put: arg evaluate]
			ifFalse: [blockTuple at: i + 3 put: arg asBlockTuple]].

	trueBlock
		ifNil: [blockTuple at: blockTuple size - 1 put: nil]
		ifNotNil: [blockTuple at: blockTuple size - 1 put: trueBlock tupleSequence].

	falseBlock
		ifNil: [blockTuple at: blockTuple size put: nil]
		ifNotNil: [blockTuple at: blockTuple size put: falseBlock tupleSequence].

	^ blockTuple
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/14/2005 17:07'!
attachBlock: aBlockMorph
	"Attach the given block to me. Assume the block has been positioned correctly."

	| y |
	self addMorph: aBlockMorph.
	y _ aBlockMorph top.
	y <= (self top + elseBarY) ifTrue: [trueBlock _ aBlockMorph. ^ self].
	y <= (self bottom - CBlockBracketThickness) ifTrue: [falseBlock _ aBlockMorph. ^ self].
	nextBlock _ aBlockMorph.

! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'ee 8/11/2008 14:58'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |
	result _ #().
	self = self topBlock ifTrue: [result _ result copyWith: self topLeft -> self].

	(self isKindOf: HatBlockMorph) ifFalse: [
		ScratchTranslator isRTL
			ifTrue: [result _ result copyWith: (self topRight -> self)]
			ifFalse: [result _ result copyWith: (self topLeft -> self)]].

	trueBlock
		ifNil: [ScratchTranslator isRTL
			ifTrue: [result _ result copyWith: ((self right - 12)@(self top + self topBarHeight + 7)) -> self]
			ifFalse: [result _ result copyWith: (self topLeft + (12@(self topBarHeight + 7))) -> self]]
		ifNotNil: [trueBlock blockAttachPoints: aSet].

	falseBlock
		ifNil: [ScratchTranslator isRTL
			ifTrue: [result _ result copyWith: ((self right - 12)@(self top + elseBarY + self elseBarHeight + 9)) -> self]
			ifFalse: [result _ result copyWith: (self topLeft + (12@(elseBarY + self elseBarHeight + 9))) -> self]]
		ifNotNil: [falseBlock blockAttachPoints: aSet].

	nextBlock
		ifNil: [ScratchTranslator isRTL
			ifTrue: [result _ result copyWith: self bottomRight -> self]
			ifFalse: [result _ result copyWith: self bottomLeft -> self]]
		ifNotNil: [nextBlock blockAttachPoints: aSet].

	aSet addAll: result.
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'ee 8/11/2008 20:04'!
elseBarHeight

	 ^ (ScratchTranslator stringExtent: 'else' localized font: (ScratchFrameMorph getFont: #Label)) y
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'CWB 8/16/2010 21:22'!
exportCodeWith: anExporter
	"Exports the if/else block into a coding language"

	anExporter exportBlock: self.
	anExporter exportNestedBlock: trueBlock.
	anExporter outputTranslatedLineOf: 'else'.
	anExporter exportNestedBlock: falseBlock.
	nextBlock ifNotNil: [nextBlock exportCodeWith: anExporter].

! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/14/2005 11:35'!
falseBlock: aBlockMorph
	"Add the given block as my false nested block sequence. Delete the old nested blocks, if any."

	falseBlock ifNotNil: [falseBlock delete].
	falseBlock _ aBlockMorph.
	aBlockMorph ifNotNil: [self addMorph: aBlockMorph].
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/13/2005 20:36'!
falseBlockList
	"Answer an array containing the block sequence false-case nested stack."

	falseBlock
		ifNil: [^ #()]
		ifNotNil: [^ falseBlock blockSequence].

! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jens 4/1/2010 14:23'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newH |
	blockLayoutNeeded ifFalse: [^ self].

	"fix trueBlock, falseBlock, and nextBlock in case they've been removed from me"
	(trueBlock notNil and: [trueBlock owner ~~ self]) ifTrue: [trueBlock _ nil].
	(falseBlock notNil and: [falseBlock owner ~~ self]) ifTrue: [falseBlock _ nil].
	(nextBlock notNil and: [nextBlock owner ~~ self]) ifTrue: [nextBlock _ nil].

	self fixBlockLayoutNoWrap.
	newH _ self topBarHeight + 3.

	trueBlock
		ifNil: [newH _ newH + 15]
		ifNotNil: [
			trueBlock fixBlockLayout.
			ScratchTranslator isRTL
				ifTrue: [trueBlock position: (self right - trueBlock width - CBlockBracketThickness)@(self top + newH)]
				ifFalse: [trueBlock position: self position + (CBlockBracketThickness@newH)].
			newH _ newH + trueBlock fullBounds height.
			trueBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].

	elseBarY _ newH - 4.
	newH _ newH + self elseBarHeight + 1.

	falseBlock
		ifNil: [newH _ newH + 15]
		ifNotNil: [
			falseBlock fixBlockLayout.
			ScratchTranslator isRTL
				ifTrue: [falseBlock position: (self right - falseBlock width - CBlockBracketThickness)@(self top + newH)]
				ifFalse: [falseBlock position: self position + (CBlockBracketThickness@newH)].
			newH _ newH + falseBlock fullBounds height.
			falseBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].

	newH _ newH + CBlockBracketThickness.
	self height: newH.
	nextBlock ifNotNil: [ScratchTranslator isRTL
		ifTrue: [nextBlock position: (self right - nextBlock width)@(self bottom - 4)]
		ifFalse: [nextBlock position: self left@(self bottom - 4)]].

	ScratchTranslator isRTL
		ifTrue: [elseMorph position: (self right - elseMorph width - 6)@(self top + elseBarY
			+ ((ScratchTranslator centerOffsetForButtonWithFont: (ScratchFrameMorph getFont: #Label)) // 4))]
		ifFalse: [elseMorph position: (self left + 6)@(self top + elseBarY
			+ ((ScratchTranslator centerOffsetForButtonWithFont: (ScratchFrameMorph getFont: #Label)) // 4))].
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/13/2005 20:31'!
litUp: aBoolean
	"Overridden to suppress highlighting of control structures. Do nothing."! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/13/2005 20:31'!
nextBlock
	"Answer the block myself in the block sequence or nil if I am the last block in the sequence. Each block is a submorph of the previous block."

	^ nextBlock
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/13/2005 20:31'!
nextBlock: aBlockMorph
	"Add the given block as the block following me. Delete old nextBlock, if any."

	self nextBlock ifNotNil: [self nextBlock delete].
	nextBlock _ aBlockMorph.
	aBlockMorph ifNotNil: [self addMorph: aBlockMorph].
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 11/29/2006 12:22'!
nonControlFlowSubmorphs
	"Answer a collection of submorphs minus any blocks that are part of the control flow. For example, command blocks omit their submorph that is the next block in the block sequence, C-blocks omit both their next block and the first block of their nested block list, etc."

	^ submorphs select: [:m |
		(m ~~ trueBlock) &
		(m ~~ falseBlock) &
		(m ~~ nextBlock)]
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/13/2005 20:46'!
printCodeOn: aStream indent: indent
	"Append a human-readable string for this block on the given stream."

	indent timesRepeat: [aStream nextPutAll: '    '].
	submorphs do: [:m |
		(m ~~ trueBlock) & (m ~~ falseBlock) & (m ~~ nextBlock) ifTrue: [
			self printCodeSubmorph: m on: aStream.
			aStream space]].
	aStream cr.
	trueBlock ifNotNil: [trueBlock printCodeOn: aStream indent: indent + 1].
	indent timesRepeat: [aStream nextPutAll: '    '].
	aStream nextPutAll: 'else'; cr.
	falseBlock ifNotNil: [falseBlock printCodeOn: aStream indent: indent + 1].
	nextBlock ifNotNil: [nextBlock printCodeOn: aStream indent: indent].
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 11/29/2006 12:21'!
topBarHeight
	"Answer the height of the top bar."

	| nonBlockSubmorphs |
	nonBlockSubmorphs _ self submorphs select: [:m |
		(m isKindOf: BlockMorph) not or: [argMorphs includes: m]].
	^ nonBlockSubmorphs inject: CBlockBracketThickness into: [:h :m | h max: (m height + 4)].

! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/14/2005 11:34'!
trueBlock: aBlockMorph
	"Add the given block as my true nested block sequence. Delete the old nested blocks, if any."

	trueBlock ifNotNil: [trueBlock delete].
	trueBlock _ aBlockMorph.
	aBlockMorph ifNotNil: [self addMorph: aBlockMorph].
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'jm 12/13/2005 20:36'!
trueBlockList
	"Answer an array containing the block sequence true-case nested stack."

	trueBlock
		ifNil: [^ #()]
		ifNotNil: [^ trueBlock blockSequence].

! !


!IfElseBlockMorph methodsFor: 'enchanting' stamp: 'JM 12/5/2011 16:02'!
createShortNamesForScriptVariables: aNumber

	"Overrides default behaviour to ensure the nested commands are checked for script variable declarations"

	| nextIndex |
	nextIndex _ aNumber.

	"ensures that declarations within literal commands / reporters are told to generate"
	trueBlock ifNotNil: [ nextIndex _ trueBlock createShortNamesForScriptVariables: nextIndex ].
	falseBlock ifNotNil: [ nextIndex _ falseBlock createShortNamesForScriptVariables: nextIndex ].
	

	^ super createShortNamesForScriptVariables: nextIndex! !

!IfElseBlockMorph methodsFor: 'enchanting' stamp: 'JM 10/20/2011 16:54'!
lambdaBlocks

	"overrides default behaviour to ensure that nested blocks in control structures are traversed"
	| lambdas |

	lambdas _ OrderedCollection new.
	trueBlock ifNotNil: [ lambdas addAll: trueBlock lambdaBlocks ].
	falseBlock ifNotNil: [ lambdas addAll: falseBlock lambdaBlocks ].
	lambdas addAll: super lambdaBlocks.
	^ lambdas! !

!IfElseBlockMorph methodsFor: 'enchanting' stamp: 'JM 10/21/2011 15:05'!
reports

	"returns true if both the if and else blocks have a return statement"
	^ (trueBlock ~= nil and: [ trueBlock reports ]) & (falseBlock ~= nil and: [ falseBlock reports ])! !

!IfElseBlockMorph methodsFor: 'enchanting' stamp: 'JM 12/5/2011 16:16'!
scriptVarShortNames

	"overrides default behaviour to ensure the nested blocks are queried"
	| names |
	
	"get names from the if / else blocks firs"
 	trueBlock ifNil: [ names _ Dictionary new ] ifNotNil: [ names _ trueBlock scriptVarShortNames ].
	falseBlock ifNotNil: [ falseBlock scriptVarShortNames associationsDo: [ :assoc | names at: assoc key put: assoc value ]].
	
	super scriptVarShortNames associationsDo: [ :assoc | names at: assoc key put: assoc value ].
	
	^ names! !


!IfElseBlockMorph methodsFor: 'byob' stamp: 'jens 1/5/2010 12:45'!
blockWidth
	| maxWidth |
	maxWidth _ 0.
	self trueBlockList, self falseBlockList do: [:b |
			maxWidth _ maxWidth max: b blockWidth ].
	^self width max: CBlockBracketThickness + maxWidth! !

!IfElseBlockMorph methodsFor: 'byob' stamp: 'jens 4/20/2010 12:38'!
isCShape

	^ true! !

!IfElseBlockMorph methodsFor: 'byob' stamp: 'jens 4/20/2010 12:36'!
nests: aBlock

	(trueBlock isKindOf: BlockMorph) 
		ifTrue: [ (trueBlock blockSequence includes: aBlock)
			ifTrue: [^ true]].

	(falseBlock isKindOf: BlockMorph) 
		ifTrue: [ ^ (falseBlock blockSequence includes: aBlock)].

	^ false! !

!IfElseBlockMorph methodsFor: 'byob' stamp: 'jens 6/28/2010 21:59'!
tabFields

	| fields tr fl tfields ffields nxt nxtFields |
	tfields _ OrderedCollection new.
	ffields _ OrderedCollection new.
	nxtFields _ OrderedCollection new.

	fields _ OrderedCollection new.
	self nonControlFlowSubmorphs do: [:m |
		(m isKindOf: ExpressionArgMorph)
			ifTrue: [fields add: m ]
			ifFalse: [(m respondsTo: #tabFields)
				ifTrue: [fields addAll: m tabFields ]]]. 

	tr _ trueBlock.
	tr ifNotNil: [
		tfields _	 tr tabFields ].

	fl _ falseBlock.
	fl ifNotNil: [
		ffields _ fl tabFields ].

	nxt _ self nextBlock.
	nxt ifNotNil: [
		nxtFields _ nxt tabFields ].

	^ fields, tfields, ffields, nxtFields ! !
