NXTDCMotor subclass: #NXTMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!
!NXTMotor commentStamp: '<historical>' prior: 0!
An NXT motor, which has a built-in encoder.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTMotor class
	instanceVariableNames: ''!

!NXTMotor class methodsFor: 'accessing' stamp: 'CWB 12/18/2010 13:43'!
baseName

	^ 'NXT motor'! !

!NXTMotor class methodsFor: 'accessing' stamp: 'CWB 12/18/2010 13:44'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."

	^ #(
		'NXT Motor'
	).! !


!NXTMotor class methodsFor: 'block specs' stamp: 'CWB 12/18/2010 16:09'!
configBlockSpec

	^ 'Drives a motor with an encoder--a %p--named %s'.! !

!NXTMotor class methodsFor: 'block specs' stamp: 'CWB 7/18/2012 12:13'!
obsoleteBlocks
"Block specs that are no longer active from the motor, but old ones still work."

	^ #(
		'motors'
			('rotate %P %n and wait'		-	NXTMotor:rotateByDegrees - 90)
			('rotate %P %n'					-	NXTMotor:rotateByDegreesnoWait - 90)
			('rotate %P to %n and wait'		-	NXTMotor:rotateToDegrees - 0)	 
			('rotate %P to %n'				-	NXTMotor:rotateToDegreesnoWait - 0)
			"('set speed of %P to %n /s'		-	NXTMotor:setSpeed:)"
			('set active speed of %P to %n /s'	-	NXTMotor:setActiveSpeed: - 720)

		).
! !

!NXTMotor class methodsFor: 'block specs' stamp: 'CWB 7/18/2012 12:13'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks.  Note that the 'selectors' are all unique, start with the class name followed by a colon, but do not actually have functions that go with them."

	^ #(
		'motors'
			('angle of %P in '				r	NXTMotor:angle)

			('rotate %P %n %J'				-	NXTMotor:rotateByDegrees:mayWait: - 90)

			('rotate %P to %n %J'			-	NXTMotor:rotateToDegrees:mayWait: - 0)	 

			('mark %P position as 0'		-	NXTMotor:resetAngle)

			('set %P speed to %n /s for following commands'	-	NXTMotor:setNextSpeed: - 720)

			"('speed of %P in /s'			r	NXTMotor:speed)"
			('start turning %P at %n /s'	-	NXTMotor:setSpeed: - 720)

			"('%P is stalled?'					b	NXTMotor:isStalled:)" "doesn't seem to work"

		).
! !


!NXTMotor class methodsFor: 'dropdown lists' stamp: 'CWB 11/22/2011 14:27'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"Things that can be read from the sensor or its settings"
		^ #('(until done)' '(just start it)')	
	].

	^ nil.! !
